<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: streams/IOStream/IOStream.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_i_o_stream_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">IOStream.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_IOSTREAM_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_IOSTREAM_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;QtCore/QFile&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;QApplication&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;QStandardPaths&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;QDir&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;QString&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;QtCore/QJsonDocument&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;QtCore/QJsonObject&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;QtCore/QJsonArray&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &quot;../../utils/utils/Utils.h&quot;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &quot;../../models/Database/Database.h&quot;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &quot;../../utils/SmartPointer/SmartPointer.h&quot;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &quot;../../models/People/User/User.h&quot;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;../../models/People/Admin/Admin.h&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &quot;../../models/Article/Book/Book.h&quot;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &quot;../../auth/OAuth/OAuth.h&quot;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_i_o_stream.html">   42</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_i_o_stream.html">IOStream</a> {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <a class="code" href="class_i_o_stream.html#aa59f4d583a53d0084d42665c80373acd">IOStream</a>();</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="comment">// getters</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">const</span> QString <a class="code" href="class_i_o_stream.html#ac3e47a49464ceb37fcc7d8813883ba27">getAppDirPath</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">const</span> QString <a class="code" href="class_i_o_stream.html#acd040bf507604b891aa1cae4d621aad7">getUsersDataFilePath</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">const</span> QString <a class="code" href="class_i_o_stream.html#ad0e283e64eadd042e415ee8a0a8bd793">getBooksDataFilePath</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">const</span> QString <a class="code" href="class_i_o_stream.html#a864edcac5f83b8eda0d707354dd72b84">getAuthDataFilePath</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="class_i_o_stream.html#af387fc9782b78d559e9e123f8d4b0378">   79</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="class_i_o_stream.html#af387fc9782b78d559e9e123f8d4b0378">DATA_FILES</a> {</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        USERS = 0,</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        BOOKS = 1,</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        AUTH = 2</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    };</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="comment">// read</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    std::vector&lt;User *&gt; <a class="code" href="class_i_o_stream.html#a419b2221abeaa4756de0be3e117b5fd8">readUsers</a>(QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    std::vector&lt;Book&gt; <a class="code" href="class_i_o_stream.html#a726b753d942c4053772f1f4753481076">readBooks</a>(QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <a class="code" href="class_o_auth.html">OAuth</a> <a class="code" href="class_i_o_stream.html#a99506021a117fd34df0f622bd33545f2">readOAuth</a>(QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keyword">const</span> QJsonObject <a class="code" href="class_i_o_stream.html#a1298f34f7ce16078d10823e9a6784d53">readFileToJson</a>(QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="comment">// write</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_i_o_stream.html#a4ca580f07f8515b4a2e2763dcf7adc01">writeUsers</a>(std::vector&lt;User *&gt; users, QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_i_o_stream.html#acce186afe3fd4a4a11a1499d593aa8d1">writeBooks</a>(std::vector&lt;Book&gt; books, QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_i_o_stream.html#a40e2bd3e025d41de39c18e72d853b013">writeOAuth</a>(<a class="code" href="class_o_auth.html">OAuth</a> oauth, QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_i_o_stream.html#aae24a6ac3c331a95e8438e7616eefa3b">writeFileAsJson</a>(QJsonDocument jsonData, QString filePath) <span class="keyword">const</span>;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keyword">static</span> QString usersDatabaseFileName;  <span class="comment">// name of file of users database</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keyword">static</span> QString booksDatabaseFileName;  <span class="comment">// name of file of books database</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keyword">static</span> QString authDatabaseFileName;  <span class="comment">// name of file of authentications database</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    QDir appDirPath;  <span class="comment">// path to app data directory</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    QString usersDataFilePath;  <span class="comment">// path to app users database</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    QString booksDataFilePath;  <span class="comment">// path to app books database</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    QString authDataFilePath;  <span class="comment">// path to app authentications database</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordtype">void</span> setupAppDataFileNames();</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <span class="keywordtype">bool</span> setupAppDataPathsOrFail();</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <span class="comment">// parsers</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keyword">const</span> <a class="code" href="class_book.html">Book</a> parseBook(QJsonObject rawBook) <span class="keyword">const</span>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keyword">const</span> <a class="code" href="class_o_auth_id.html">OAuthId</a> parseOauthId(QJsonObject rawOauthId) <span class="keyword">const</span>;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <a class="code" href="class_user.html">User</a> *parseUser(QJsonObject rawUser) <span class="keyword">const</span>;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="comment">// converters</span></div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <span class="keyword">const</span> QJsonObject toJson(<a class="code" href="class_book.html">Book</a> book) <span class="keyword">const</span>;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keyword">const</span> QJsonObject toJson(<a class="code" href="class_user.html">User</a> *user) <span class="keyword">const</span>;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keyword">const</span> QJsonObject toJson(<a class="code" href="class_o_auth_id.html">OAuthId</a> <span class="keywordtype">id</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;};</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="preprocessor">#endif //LIBRARYMGR_IOSTREAM_H</span></div><div class="ttc" id="class_book_html"><div class="ttname"><a href="class_book.html">Book</a></div><div class="ttdoc">Library book with author, ISBN and status. </div><div class="ttdef"><b>Definition:</b> Book.h:28</div></div>
<div class="ttc" id="class_i_o_stream_html_af387fc9782b78d559e9e123f8d4b0378"><div class="ttname"><a href="class_i_o_stream.html#af387fc9782b78d559e9e123f8d4b0378">IOStream::DATA_FILES</a></div><div class="ttdeci">DATA_FILES</div><div class="ttdef"><b>Definition:</b> IOStream.h:79</div></div>
<div class="ttc" id="class_i_o_stream_html_ad0e283e64eadd042e415ee8a0a8bd793"><div class="ttname"><a href="class_i_o_stream.html#ad0e283e64eadd042e415ee8a0a8bd793">IOStream::getBooksDataFilePath</a></div><div class="ttdeci">const QString getBooksDataFilePath() const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:56</div></div>
<div class="ttc" id="class_i_o_stream_html_acd040bf507604b891aa1cae4d621aad7"><div class="ttname"><a href="class_i_o_stream.html#acd040bf507604b891aa1cae4d621aad7">IOStream::getUsersDataFilePath</a></div><div class="ttdeci">const QString getUsersDataFilePath() const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:52</div></div>
<div class="ttc" id="class_i_o_stream_html"><div class="ttname"><a href="class_i_o_stream.html">IOStream</a></div><div class="ttdef"><b>Definition:</b> IOStream.h:42</div></div>
<div class="ttc" id="class_i_o_stream_html_a99506021a117fd34df0f622bd33545f2"><div class="ttname"><a href="class_i_o_stream.html#a99506021a117fd34df0f622bd33545f2">IOStream::readOAuth</a></div><div class="ttdeci">OAuth readOAuth(QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:97</div></div>
<div class="ttc" id="class_i_o_stream_html_aa59f4d583a53d0084d42665c80373acd"><div class="ttname"><a href="class_i_o_stream.html#aa59f4d583a53d0084d42665c80373acd">IOStream::IOStream</a></div><div class="ttdeci">IOStream()</div><div class="ttdef"><b>Definition:</b> IOStream.cpp:23</div></div>
<div class="ttc" id="class_user_html"><div class="ttname"><a href="class_user.html">User</a></div><div class="ttdef"><b>Definition:</b> User.h:31</div></div>
<div class="ttc" id="class_i_o_stream_html_ac3e47a49464ceb37fcc7d8813883ba27"><div class="ttname"><a href="class_i_o_stream.html#ac3e47a49464ceb37fcc7d8813883ba27">IOStream::getAppDirPath</a></div><div class="ttdeci">const QString getAppDirPath() const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:48</div></div>
<div class="ttc" id="class_i_o_stream_html_a726b753d942c4053772f1f4753481076"><div class="ttname"><a href="class_i_o_stream.html#a726b753d942c4053772f1f4753481076">IOStream::readBooks</a></div><div class="ttdeci">std::vector&lt; Book &gt; readBooks(QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:86</div></div>
<div class="ttc" id="class_i_o_stream_html_acce186afe3fd4a4a11a1499d593aa8d1"><div class="ttname"><a href="class_i_o_stream.html#acce186afe3fd4a4a11a1499d593aa8d1">IOStream::writeBooks</a></div><div class="ttdeci">void writeBooks(std::vector&lt; Book &gt; books, QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:120</div></div>
<div class="ttc" id="class_i_o_stream_html_a419b2221abeaa4756de0be3e117b5fd8"><div class="ttname"><a href="class_i_o_stream.html#a419b2221abeaa4756de0be3e117b5fd8">IOStream::readUsers</a></div><div class="ttdeci">std::vector&lt; User * &gt; readUsers(QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:75</div></div>
<div class="ttc" id="class_o_auth_html"><div class="ttname"><a href="class_o_auth.html">OAuth</a></div><div class="ttdef"><b>Definition:</b> OAuth.h:30</div></div>
<div class="ttc" id="class_i_o_stream_html_aae24a6ac3c331a95e8438e7616eefa3b"><div class="ttname"><a href="class_i_o_stream.html#aae24a6ac3c331a95e8438e7616eefa3b">IOStream::writeFileAsJson</a></div><div class="ttdeci">void writeFileAsJson(QJsonDocument jsonData, QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:145</div></div>
<div class="ttc" id="class_i_o_stream_html_a1298f34f7ce16078d10823e9a6784d53"><div class="ttname"><a href="class_i_o_stream.html#a1298f34f7ce16078d10823e9a6784d53">IOStream::readFileToJson</a></div><div class="ttdeci">const QJsonObject readFileToJson(QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:64</div></div>
<div class="ttc" id="class_i_o_stream_html_a40e2bd3e025d41de39c18e72d853b013"><div class="ttname"><a href="class_i_o_stream.html#a40e2bd3e025d41de39c18e72d853b013">IOStream::writeOAuth</a></div><div class="ttdeci">void writeOAuth(OAuth oauth, QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:132</div></div>
<div class="ttc" id="class_i_o_stream_html_a4ca580f07f8515b4a2e2763dcf7adc01"><div class="ttname"><a href="class_i_o_stream.html#a4ca580f07f8515b4a2e2763dcf7adc01">IOStream::writeUsers</a></div><div class="ttdeci">void writeUsers(std::vector&lt; User * &gt; users, QString filePath) const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:108</div></div>
<div class="ttc" id="class_o_auth_id_html"><div class="ttname"><a href="class_o_auth_id.html">OAuthId</a></div><div class="ttdef"><b>Definition:</b> OAuthId.h:28</div></div>
<div class="ttc" id="class_i_o_stream_html_a864edcac5f83b8eda0d707354dd72b84"><div class="ttname"><a href="class_i_o_stream.html#a864edcac5f83b8eda0d707354dd72b84">IOStream::getAuthDataFilePath</a></div><div class="ttdeci">const QString getAuthDataFilePath() const </div><div class="ttdef"><b>Definition:</b> IOStream.cpp:60</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d7ca51e70b82f7aa7b8306326f8020c9.html">streams</a></li><li class="navelem"><a class="el" href="dir_5491bf14cc2d8d56ebc0a0be74dbcea9.html">IOStream</a></li><li class="navelem"><b>IOStream.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
